 Unit HashTbl;

 Interface
 Procedure Init;
 type IPtype = string[16];
  type rec = record   {  ⠡ }
     IP:   IPtype;
     OS:   string[6];
     Prot: string[5];
     next : integer; { 㪠⥫  ᨭ }
     end;
 Function Insert(str : rec) : boolean;
 Function Fetch(str : rec) : integer;

 Implementation
 const N=10;    { ᫮ ᥩ  ⠡ }
 const NPP=10;  { ࠧ  ९ }
 const EMPTY='Empty';  { ਧ ⮩  }
       EMPTY2=-1;  { ਧ ⮩  }



 { ⨯ ⠡ - ᭮  +  ९ }
 type Seq = array[1..N+NPP] of rec;
 var tabl : Seq;                        { ⠡ }

 { ஢ -    }
 Function Hash(IP : IPtype) : integer;
   var i:byte;
       tt: Word;
   begin
    tt:=0;
    For i:=1 to 15 do tt:=tt+ord(IP[i]);
    Hash:= tt;
   end;

{ 樠 ⠡ -  묨 ﬨ }
 Procedure Init;
   var i : integer;
   begin
     for i:=1 to N+NPP do
     begin
       tabl[i].IP:=EMPTY; tabl[i].next:=EMPTY2;
     end;
 end;


{    ⠡ }
 Function Insert(Str : rec) : boolean;
 Var addr1, addr2 : integer;  {  - ᭮, ९}

 begin
   addr1:=Hash(STR.IP); { ᫥  }
   Insert:=true;

   if tabl[addr1].IP=EMPTY then
   { -  ᭮  ᢮ -    }
     tabl[addr1].IP:=str.IP

   else { -  ᭮   }

   {  ᢮   ⠡ ९ }
   begin
   addr2:=N+1;
     while (tabl[addr2].IP<>EMPTY) and (addr2<N+NPP) do
       addr2:=addr2+1;

     if tabl[addr2].IP<>EMPTY then Insert:=false {   }
     else                    {    ९ 
                              ४ 㪠⥫  楯窥 }
         begin
             tabl[addr2].IP:=Str.IP;
             tabl[addr2].next:=tabl[addr1].next;
             tabl[addr1].next:=addr2;
         end;
     end;
 end;

 { 롮ઠ  ⠡ }
 Function Fetch(str : rec) : integer;
   Var addr : integer;
   begin
   addr:=Hash(str.ip); { ᫥  }

   if tabl[addr].IP=Str.IP then          {   ᢮  }
     Fetch:=addr {   ᭮ ணࠬ }

   else if tabl[addr].IP=EMPTY then   {   ⠡ }
     Fetch:=EMPTY2 {      ⠡ }

   else {   ⠡ ९ }
     begin
       addr:=tabl[addr].next;
       while (addr<>EMPTY2) and (tabl[addr].IP<>Str.IP) do
         addr:=tabl[addr].next;
       Fetch:=addr;         {   .९  EMPTY }
     end;
  end; {  㭪樨 }

 END.