#include <conio.h>
#include <iostream.h>
#include <stdlib.h>
#include <iomanip.h>
#include <string.h>
#include <dos.h>
#include <time.h>

#define max      10
#define elem     10
#define xashsize 10

const char* typeoc[]={"WinXP","WinME","Win98","MacOC","Linux","Unix"};
#define typenum 6
const char* typepr[]={"TCP/IP","IPX","IPC","NetBios","NetLink"};
#define typepro 5


struct table
 {
  unsigned long     addres;
  char		    oc[max];
  char              protoc[max];
 };

struct spis
 {
  unsigned long   key;
  table          *addr;
  spis		 *next;
 };

struct mas
 {
  spis *next;
 };

void init(table *p)
 {
  for (int i=0;i<elem;i++)
   {
    (p+i)->addres=random(1000000);
    strcpy((p+i)->oc,typeoc[random(typenum)]);
    strcpy((p+i)->protoc,typepr[random(typepro)]);
   }
 }
void outt(table *p)
 {
  cout<<"\n Addres of server    Operation System    Protocol\n\n";
  for (int i=0;i<elem; i++)
   {
    //     012301234567890012301234567Linux1234501234NetBios
    //         0012345678             0123456
    cout<<"    ";
    cout.fill('0');
    cout<<setw(10)<<(p+i)->addres;
    cout.fill(' ');
    cout<<"             ";
    cout<<setw(7)<<(p+i)->oc;
    cout<<"        ";
    cout<<setw(7)<<(p+i)->protoc;
    cout<<endl;
   }
 }
int funxash(unsigned long f)
 {
  return f%xashsize;
 }

void initxash(mas *x, table *p)
 {
  for (int i=0;i<xashsize;i++)
   (x+i)->next=NULL;
  spis *t;
  for (i=0;i<elem;i++)
   {
    if ((x+funxash((p+i)->addres))->next==NULL)
     {
      t=(x+funxash((p+i)->addres))->next=new(spis);
      t->next=NULL;
     }
    else
     {
      spis* temp=(x+funxash((p+i)->addres))->next;
      t=new(spis);
      (x+funxash((p+i)->addres))->next=t;
      t->next=temp;
     }
    t->key=(p+i)->addres;
    t->addr=(p+i);
   }
 }


void search(mas *x, unsigned long key)
 {
  spis *t=(x+funxash(key))->next;
  while (t)
   {
    if (t->key==key)
     {
      cout<<"\nKey was finded: addres: "<<t->addr->addres<<" OC: "<<t->addr->oc;
      cout<<" protocol: "<<t->addr->protoc;
      return;
     }
    t=t->next;
   }
  cout<<"\nKey was not finded\n";
 }

void search(table *x, unsigned long key)
 {
  for (int i=0; i<elem; i++)
   if ((x+i)->addres==key)
     {
      cout<<"\nKey was finded: addres: "<<(x+i)->addres<<" OC: "<<(x+i)->oc;
      cout<<" protocol: "<<(x+i)->protoc;
      return;
     }
  cout<<"\nKey was not finded\n";
 }
void main(void)
 {
  struct time t;

  mas xash[xashsize];
  randomize();
  clrscr();
  table a[elem];
  init(a);
  outt(a);

  gettime(&t);
  float a1=t.ti_sec+(float)t.ti_hund/100,a2;
  initxash(xash,a);

  gettime(&t);
  a2=t.ti_sec+(float)t.ti_hund/100;
  cout<<"time of creating xash: "<<a2-a1;

  cout<<"\nInput key for searching: ";
  unsigned long key;
  cin>>key;
  cout<<"\nXash find: \n";

  gettime(&t);
  a1=t.ti_sec+(float)t.ti_hund/100;


  search(xash,key);

  gettime(&t);
  a2=t.ti_sec+(float)t.ti_hund/100;

  cout<<"\nTime of searching = "<<a2-a1;
  cout<<"\nSimple find: \n";

  gettime(&t);
  a1=t.ti_sec+(float)t.ti_hund/100;

  search(a,key);

  gettime(&t);
  a2=t.ti_sec+(float)t.ti_hund/100;
  cout<<"\nTime of searching = "<<a2-a1;

  getch();
 }





