#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <string.h>

#define RAZM 10
struct sdata
{
  unsigned num;
  char name[20];
  unsigned place;
};

	struct sworker
	{
		sdata data;
		sworker *next;
		sworker *prev;
		sworker *beg;
		sworker *curr;
	};

	sworker *worker;
	sworker *p[RAZM];

	int Build(int position,sdata);
	void Del();
	void First();
	void Insert();
	int Kesh(unsigned num);
	void Show();
	void Search();
	void Death();
	void Menu();
	void Update_File();

	void main(void)
	{
		  FILE *f;
		  sdata tdata;
		  int pos=0;
		  clrscr();
		  First();
		  if((f=fopen("c:\\user\\dimon\\hew\\1.txt","rt"))==NULL)
		  {
				cout<<"Error reading input file\n";
				getch();
				exit(1);
		  }
		  while(!feof(f))
		  {
				 fscanf(f,"%d",&tdata.num);
				 fscanf(f,"%s",tdata.name);
				 fscanf(f,"%d",&tdata.place);
				 pos=Kesh(tdata.num);
				 Build(pos,tdata);
		  }
			 fclose(f);
			 Show();
			 Menu();
			 Death();
			 getch();
		}

	int Kesh(unsigned num)
	{
		 int tmp=0;
		 tmp+=num%10;
		 tmp+=(num%100)/10;
		 tmp+=(num%1000)/100;
		 tmp+=(num%10000)/1000;
		 tmp+=(num%100000)/10000;
		 tmp+=(num%1000000)/100000;
		 return tmp%RAZM;
	}

	void First()
	{	 for(int i=0;i<RAZM;i++)
			p[i]=NULL;
	}

	int Build(int position, sdata dat)
	{
		 sworker *pt,*nw,*nxt;
		 int kol=0;
		  pt=new sworker;
		  if(!pt)
		  {
			cout<<"Error"<<endl;
			getch();
			exit(1);
		  }
		  nw=p[position];
		  if(!nw)
		  {
				p[position]=pt;
				p[position]->next=NULL;
				p[position]->curr=pt;
		  }
		  else
		  {
			 pt->next=p[position]->curr;
			 p[position]->curr->prev=pt;
			 p[position]->curr=pt;
			}
		 p[position]->curr->data=dat;
		 return 0;
	}

void Insert()
{
	 sdata data;
	 int pos;
	  scanf("%d",&data.num);
	  scanf("%s",data.name);
	  scanf("%d",&data.place);
	  pos=Kesh(data.num);
	  Build(pos,data);
	  cout<<"\nData inserted in "<<pos<<" position\n";
	  delay(1000);
}

void Del()
{
		 int pos;
		 unsigned num;
		 sworker *pt,*pt1=NULL,*pt2=NULL;
		 scanf("%d",&num);
		 pos=Kesh(num);
		 pt=p[pos]->curr;
		 pt1=pt;
		 while(((pt->data.num)!=num)&&(pt))
			pt=pt->next;
		 if((pt1==pt)&&(pt))
			  {
				  pt1=pt->next;
				  delete pt;
				  p[pos]->curr=pt1;
				  p[pos]->curr->prev=NULL;
			  }
		  if(!pt)
			{	  cout<<"This string is absent\n";
				  getch();
				  return;
			 }
		  if(!pt->next)
			{
				  sworker *temp;
				  sworker *temp1 = p[pos]->curr;
				  temp = p[pos];
				  p[pos] = temp->prev;
				  delete temp;
				  p[pos]->next = 0;
				  p[pos]->curr = temp1;
			}
			else
				{	 pt1=pt->prev;
					 pt2=pt->next;
					 pt1->next=pt2;
					 delete pt;
				}
}

void Show()
{
	 sworker *ptr;
	 int len,o;
	 for(int i=0;i<RAZM;i++)
	 {
		ptr=p[i];
		cout<<"Segment "<<i<<" ";
		if(ptr)
		 {	   ptr=p[i]->curr;
			 while(ptr)
			 {
				cout<<ptr->data.num<<" "<<ptr->data.name<<" "<<ptr->data.place<<" // ";
				ptr=ptr->next;
			 }
		  }
			cout<<"\n";
		 }
	}
void Search()
{
		  sworker *ptr;
		  int pos;
		  unsigned num;
		  cout<<"\nInput num\n";
		  cin>>num;
		  pos=Kesh(num);
		  ptr=p[pos]->curr;
		  if(ptr)
		  {
			  while(((ptr->data.num)!=num)&&(ptr))
				ptr=ptr->next;
			  if(ptr)
			  {	cout<<" is present on "<<pos<<" string\n";
				getch();
				return;
				}  else
				{	cout<<num<<"  is absent\n";
				getch();
				return;
				}
			}
}

void Death()
{
		sworker *ptr;
		for(int i=0;i<RAZM;i++)
		{
			if (!p[i]) continue;
			ptr=p[i]->curr;
			while(ptr)
			{
				ptr=ptr->next;
				delete p[i]->curr;
				p[i]->curr=ptr;
			}
		}
}

void Update_File()
{
	 sworker *ptr;
	 int len,o,i;
	 char c;
	 FILE *f;
	 cout<<"Do you realy want to Update input File (y/n)\n";
	 c=getch();
	 if(c=='n')
	return;
	 if(c=='y')
	 {	  if((f=fopen("d:\\1.txt","w+t"))==NULL)
		 {	   cout<<"Error writing	input file\n";
				getch();
				exit(1);
		 }
		for(i=0;i<RAZM;i++)
		{	  ptr=p[i];
			 if(ptr)
			 {	 ptr=p[i]->curr;
				 while(ptr)
				 {
					fprintf(f,"%d",ptr->data.num);
					fputs("\n",f);
					fputs(ptr->data.name,f);
					fputs("\n",f);
					fprintf(f,"%d",ptr->data.place);
					fputs("\n",f);
					ptr=ptr->next;
				  }
			  }
		  }
		  fclose(f);
	}	 else
		return;
}
	void Menu()
	{ 	  char c;
		 do
		 {	cout<<"\n"<<"Input need number\n";
			cout<<"1 - Search\n";
			cout<<"2 - Insert\n";
			cout<<"3 - Delete\n";
			cout<<"4 - Show\n";
			cout<<"5 - Update file\n";
			cout<<"6 - Exit\n";
			c=getche();
			switch(c)
		{
			case '1': Search();clrscr();Show();break;
			case '2':  printf("\nInput string for insert\n");Insert();clrscr();Show();break;
			case '3': printf("\nInput string for delete\n");Del();clrscr();Show();break;
			case '4': clrscr();Show();break;
			case '5': clrscr();Update_File();break;
			case '6': return;cout<<"\nExit";break;
			default: cout<<" - Error of input";getch();clrscr();Show();
		  }
		}while(c!=28);
	}
