#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <time.h>
void init(void);
int Insert(int key);
int Fetch(int key);
#define EMPTY -1
#define N 15			//chislo zapisej v tablice
#define NB 3			//chislo paketov
int tabl[N];			//tablica
int keys[N]={58,0,75,19,96,38,81,52,66,62,77,4,15,79,100};
//100 - ne vstavlyaetsa po usloviju
int res[N];

void main(void)
{
	clrscr();
	init();
	printf("\nKeys -> ");
	for (int i=0;i<N;i++)
		printf("%i ",keys[i]);
	for (i=0;i<(N-1);i++)
		Insert(keys[i]);
	printf("\nHashed table -> ");
	for (i=0;i<N;i++)
	{
		printf("%i ",tabl[i]);
		if(!((i+1)%3)) printf("|");
	}
	for (i=0;i<N;i++)
	  {
		res[i]=Fetch(keys[i]);
		 printf("\nIn main res[i]=%d",res[i]);
	   }
	   printf("\n");
       printf("\nSearched keys -> ");
	for (i=0;i<N;i++)
	{
		if (res[i]==EMPTY)
			printf(" N/F ");
		else
			printf(" %i ",tabl[res[i]]);
	}
   getch();
}

void init(void)
{
	for(int i=0;i<N;i++)
		tabl[i]=EMPTY;
}
int Hash(int key)
{
	return (key%(N/NB));
}
int Insert(int key)
{
	int addr,a1,pa;

	pa=Hash(key);			//nomer paketa
	addr=pa*NB;			//nomer 1-go elementa v pakete
	int iIns=1;
	a1=addr;	  //poisk svobodnogo mesta v pakete
	while((a1<(addr+NB))&&(tabl[a1]!=EMPTY))
		a1++;
	if (a1<(addr+NB))		//svobodnoe mesto najdeno
		tabl[a1]=key;
	else				//svobodnoe mesto ne najdeno
		iIns=0;
	printf("\nIn insert addr=%d key=%d", addr, key);
	return iIns;
}
int Fetch(int key)		//viborka iz tablici
{
	int addr, a1;
	addr= Hash(key)*NB;		//nomer 1-go elementa v pakete
	a1=addr;		        //poisk v pakete
	while((a1<(addr+NB))&&(tabl[a1]!=key))
		a1++;
	if(a1<(addr+NB))
		return a1;
	else
		return EMPTY;
}