#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <conio.h>


struct listNode{
   unsigned int 	number_KEY;
   char 		name[21];
   listNode            *next;
   listNode            *pred;
};

struct hashTableNode{
   unsigned int 	KEY;
   unsigned int 	number_KEY;
   listNode	       *ADDR;
   hashTableNode       *LevelNext;
   hashTableNode       *LevelPred;
   hashTableNode       *next;
   hashTableNode       *pred;
};

listNode* 	CreateList(int);
void		PrintList(listNode*);
hashTableNode*  CreateTable(listNode*);
void 		PrintTable(hashTableNode*);
hashTableNode*	hashTableInsert(hashTableNode*,listNode*);
unsigned int 	HashFunction(unsigned int);

listNode* 	FindListNode(hashTableNode*,unsigned int);

void	deletelist(listNode*);
void 	deletehash(hashTableNode*);

void main(void)
{

     clrscr();
     listNode *List_TOP;
     hashTableNode *HashTable_TOP;


     List_TOP=CreateList(35);
//     PrintList(List_TOP);


     HashTable_TOP=CreateTable(List_TOP);
     textcolor(LIGHTBLUE);
     textbackground(CYAN);
     clrscr();
     cprintf("   hKey Values");
     window(2,3,79,24);
     textcolor(LIGHTGREEN);
     textbackground(LIGHTGRAY);
     cprintf("ͻ");
     for(int i=0;i<19;i++)
     cprintf("                                                                            ");
     cprintf("ͼ");
     window(6,4,77,22);
     gotoxy(1,1);

     PrintTable(HashTable_TOP);
     int VAL;
     printf("Input the find key -> ");
     scanf("%i",&VAL);
     listNode *find;
     find=FindListNode(HashTable_TOP,VAL);
     if(find){
	gotoxy(1,wherey());
	cprintf("Find key %s",find->name);
     }else{
	gotoxy(1,wherey());
	cprintf("Key not found");
     }
     getch();

//    for(int i=0;i<20;i++)
//       cprintf("%d\n",HashFunction(i));

//     cprintf("%d",HashFunction(15));
     deletelist(List_TOP);
//     PrintList(List_TOP);
     deletehash(HashTable_TOP);
//     PrintTable(HashTable_TOP);
/*
     getch();
     window(1, 1, 80, 25);
     textcolor(LIGHTGRAY);
     textbackground(BLACK);
     clrscr();
*/
}

listNode* CreateList(int N)
{
     listNode *head, *cur;
     int COUNT;

     srand(time(NULL));

     cur=new listNode;
     cur->next=NULL;
     cur->pred=NULL;
     itoa(0,cur->name,10);
     strcat(cur->name,"-");
     cur->number_KEY=0;

     COUNT=1;
     head=cur;

     while(COUNT!=N){

	cur->next=new listNode;
	itoa(COUNT,cur->next->name,10);
	strcat(cur->next->name,"-");
	cur->next->number_KEY=COUNT;
	cur->next->next=NULL;
	cur->next->pred=cur;
	cur=cur->next;
	COUNT++;
     }

     return head;
}

hashTableNode* CreateTable(listNode *listcur)
{
     hashTableNode *hashTableHead;

     if(listcur){
       // ᫨  ᯨ᪥ -  (   )
	// ᮧ   ⠡
	hashTableHead=new hashTableNode;
	hashTableHead->KEY=HashFunction(listcur->number_KEY);
	hashTableHead->number_KEY=listcur->number_KEY;
	hashTableHead->ADDR=listcur;
	hashTableHead->LevelNext=NULL;
	hashTableHead->LevelPred=NULL;
	hashTableHead->next=NULL;
	hashTableHead->pred=NULL;
     }else{
	return NULL;  // ᫨ ᯨ᮪ ,   ⠡ 
     }

     if(listcur->next){
	listcur=listcur->next;
     }else{
	return hashTableHead; // ᫨  ᯨ᪥  
     }

     while(listcur!=NULL){
	hashTableHead=hashTableInsert(hashTableHead,listcur);
	listcur=listcur->next;
     }

     return hashTableHead;
}

hashTableNode*	hashTableInsert(hashTableNode *hashTableHead, listNode *listcur)
{
     hashTableNode *hashTablecur, *hashTabletmp, *Predcur;

     int TableInsertFLAG=0;
     int LevelInsertFLAG=0;

     // ନ㥬   ⠢
     hashTabletmp=new hashTableNode;
     hashTabletmp->KEY=HashFunction(listcur->number_KEY);
     hashTabletmp->number_KEY=listcur->number_KEY;
     hashTabletmp->ADDR=listcur;
     hashTabletmp->LevelNext=NULL;
     hashTabletmp->LevelPred=NULL;
     hashTabletmp->next=NULL;
     hashTabletmp->pred=NULL;
     hashTablecur=hashTableHead;
     while(
	   ( ( TableInsertFLAG=(hashTablecur == NULL) ) == 0 )
	   &&
	   ( ( LevelInsertFLAG=(hashTablecur->KEY == hashTabletmp->KEY) ) == 0 )
	   &&
	    ( ( TableInsertFLAG=(hashTablecur->KEY > hashTabletmp->KEY) ) != 1 )

	  )
     {
	 Predcur=hashTablecur;
	 hashTablecur=hashTablecur->next;
     }

     if(TableInsertFLAG){
	if(hashTableHead==hashTablecur){
	   hashTableHead=hashTabletmp;
	   hashTabletmp->next=hashTablecur;
	   hashTablecur->pred=hashTabletmp;
	}else{
	   hashTabletmp->next=hashTablecur;
	   hashTabletmp->pred=Predcur;
	   Predcur->next=hashTabletmp;
	   if(hashTablecur)
	      hashTablecur->pred=hashTabletmp;
	}
     }

     if(LevelInsertFLAG){
	hashTableNode *curLevelNext;

	curLevelNext=hashTablecur->LevelNext;
	if(!curLevelNext){
	   hashTabletmp->next=NULL;
	   hashTabletmp->pred=NULL;
	   hashTabletmp->LevelNext=NULL;
	   hashTabletmp->LevelPred=hashTablecur;
	   hashTablecur->LevelNext=hashTabletmp;

	}else{
	   while(curLevelNext->next!=NULL)
	      curLevelNext=curLevelNext->next;
	   hashTabletmp->next=NULL;
	   hashTabletmp->pred=NULL;
	   hashTabletmp->LevelNext->next=NULL;
	   hashTabletmp->LevelPred->pred=curLevelNext;
	   curLevelNext->next=hashTabletmp;

	}
     }


     return hashTableHead;
}


void PrintList(listNode* cur)
{
     while(cur!=NULL){
	cprintf("number_KEY - %d Name - %s\n\r",cur->number_KEY, cur->name);
	cur=cur->next;
     }
}

void	deletelist(listNode*cur)
{
     while(cur!=NULL){
	delete(cur->pred);
	cur=cur->next;
     }

}
void 	deletehash(hashTableNode *cur)
{
     hashTableNode *tmp;

     while(cur!=NULL){
	delete(cur->pred);
	if(cur->LevelNext){
	  tmp=cur->LevelNext;
	   while(tmp!=NULL){
	      tmp=tmp->next;
	      delete(tmp->pred);
	   }

	}
	cur=cur->next;
     }

}


void PrintTable(hashTableNode* cur)
{
     hashTableNode *tmp;

     while(cur!=NULL){
	cprintf("%2d number_KEY - %2d",cur->KEY, cur->number_KEY);
	if(cur->LevelNext){
	  tmp=cur->LevelNext;
	   while(tmp!=NULL){
	      cprintf("%5d ", tmp->ADDR->number_KEY);
	      tmp=tmp->next;
	   }

	}

	cprintf("\n\r");
	cur=cur->next;
     }
}


unsigned int HashFunction(unsigned int R)
{

    char	string[6],
		buffer[4];
    int 	LEN;

    R*=R;

    itoa(R, string, 10);

    LEN=strlen(string);

    if(LEN%2){
       //  
       buffer[0]=string[LEN/2];
       buffer[1]='\0';
    }else{       //  
       buffer[0]=string[LEN/2-1];
       buffer[1]=string[LEN/2];
       buffer[2]='\0';
    }

    return atoi(buffer);
}

listNode* FindListNode(hashTableNode *cur, unsigned int R)
{
    hashTableNode *tmp;
    int KEY;

    KEY=HashFunction(R);
    while((cur->KEY!=KEY)&&(cur!=NULL))
	cur=cur->next;
    if(cur->ADDR->number_KEY==R)
       return cur->ADDR;
    else{
      tmp=cur->LevelNext;
      if(tmp)
	 while(tmp!=NULL){
	       if(tmp->ADDR->number_KEY==R)
		  return tmp->ADDR;
	       tmp=tmp->next;
	    }
	 else
	   return NULL;

    }
}