#include <iostream.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

#define SIZE 10

struct pole
{
	char *kod;
	char *name;
	char *plow;
	int pos;
};

pole *osnovna[SIZE],*dopom[SIZE];
int dsize = 0;

int HESH(char *kod)
{
	int sum=0;
	for(int i=0;i<6;i++)
	{
		sum += (kod[i]-48)^2;
	}
	return sum % SIZE;
}

void insert(int pos,char *kod,char *name,char *plow)
{
	if(osnovna[pos]==NULL)
	{
		osnovna[pos] = new pole;
		strcpy(osnovna[pos]->kod,kod);
		strcpy(osnovna[pos]->name,name);
		strcpy(osnovna[pos]->plow,plow);
	}
	else
	{
		dopom[dsize] = new pole;
		strcpy(dopom[dsize]->kod,kod);
		strcpy(dopom[dsize]->name,name);
		strcpy(dopom[dsize]->plow,plow);
		dopom[dsize]->pos = pos;
		dsize++;
	}
}

void add()
{
	clrscr();
	char kod[7],name[20],plow[10];
	int pos;
	cout<<"Enter code: ";
	gets(kod);
	cout<<"Enter name: ";
	gets(name);
	cout<<"Enter square: ";
	gets(plow);
	pos = HESH(kod);
	cout<<"\n\n";
	insert(pos,kod,name,plow);
}

void show()
{
	clrscr();
	for(int i=0;i<SIZE;i++)
	{
		if(osnovna[i]!=NULL)
		{
			cout<<osnovna[i]->kod<<" ";
			cout<<osnovna[i]->name<<" ";
			cout<<osnovna[i]->plow<<"\n";
		}

	}
	for(i=0;i<dsize;i++)
	{
		cout<<dopom[i]->kod<<" ";
		cout<<dopom[i]->name<<" ";
		cout<<dopom[i]->plow<<"\n";
	}
	cout<<"\n\n";
}

int search(char *kod)
{
	clrscr();
	int pos;
	pos = HESH(kod);
	if(osnovna[pos]==NULL) cout<<"No such book found...";
	else
	{
		int s=1;
		for(int j=0;j<6;j++) if(osnovna[pos]->kod[j]!=kod[j]) s=0;
		if(s==1)
		{
			cout<<osnovna[pos]->kod<<" ";
			cout<<osnovna[pos]->name<<" ";
			cout<<osnovna[pos]->plow<<"\n\n\n";
			return pos;
		}
		else
		{
			for(int n=0;n<dsize;n++)
			{
				s=1;
				for(int j=0;j<6;j++) if(dopom[n]->kod[j]!=kod[j]) s=0;
				if(s==1)
				{
					cout<<dopom[n]->kod<<" ";
					cout<<dopom[n]->name<<" ";
					cout<<dopom[n]->plow<<"\n\n\n";
					return n*100;
				}
			}
			if(s==0) cout<<"No such book found...";
		}
	}
	cout<<"\n\n";
	return -1;
}

void search()
{
	char *kod;
	cout<<"Enter code: ";
	gets(kod);
	search(kod);
}

void del()
{
	clrscr();
	char kod[7];
	int pos;
	cout<<"Enter code: ";
	gets(kod);
	pos = search(kod);
	if(pos<SIZE)
	{
		delete osnovna[pos];
		osnovna[pos] = NULL;
	}
	else
	{
		pos = pos/100;
		delete dopom[pos];
		dopom[pos] = NULL;
	}
}

void clearmem()
{
	for(int i=0;i<SIZE;i++)
	{
		if(osnovna[i]!=NULL) delete osnovna[i];
	}
	for(i=0;i<dsize;i++) delete dopom[i];
}

void main()
{
	clrscr();
	FILE *f;
	char *str,kod[7],name[20],plow[10];
	for(int n=0;n<SIZE;n++)
	{
		osnovna[n] = NULL;
		dopom[n] = NULL;
	}
	f = fopen("data.txt","rt");
	if(f==NULL) {cout<<"Error opening file..."; return;}
	while(!feof(f))
	{
		fgets(str,255,f);
		for(int i=0;i<6;i++)
		{
			kod[i] = str[i];
		}
		for(i=7;;i++)
		{
			name[i-7] = str[i];
			if(name[i-7]==' '){name[i-7] = '\0'; break;}
		}
		int j=i+1;
		for(i=0;;i++,j++)
		{
			plow[i] = str[j];
			if(plow[i]=='\n'){plow[i] = '\0'; break;}
		}
		int pos = HESH(kod);
		insert(pos,kod,name,plow);
	}

//=====================================================================

	int exit = 0;
	while(!exit)
	{
	cout<<"1. Insert new\n2. Show\n3. Search\n4. Delete\n5. Exit";
	char ch;
	ch = getch();
	clrscr();
	switch(ch)
	{
		case '1': add(); break;
		case '2': show(); break;
		case '3': search(); break;
		case '4': del(); break;
		case '5': exit = 1; clearmem(); break;
	}
	}
}